
hirom
header

; massive optimization begin!

org $C04A54
again:
LDA $1850,X
BIT #$40       ; originally this was AND, so A had to be reloaded after this
BEQ not_this
AND #$07
CMP $1A6D
BNE not_this
JSR $AEE8      ; set $1E to this character's max HP
LDA $1614,Y    ; status byte 1
BIT #$C2       ; stone, zombie, dead?
BNE dead       ; branch if any inflicted
JSR continue_tin
BEQ no_tin3
LDA $161C,Y   ; stamina
LSR A
LSR A
REP #$21
ADC $1609,Y    ; add 25% stamina with current HP
CMP $1E
BCC good_HP
LDA $1E
good_HP:
STA $1609,Y
TDC
SEP #$20
no_tin3:
LDA $1614,Y    ; status byte 1
AND #$04
BEQ not_poison
TDC
LDA #$0F
STA $11F0
REP #$20
XBA            ; A = #$0F00 now, this saves a byte
STA $0796
REP #$20
LDA $1E
LSR #5
STA $1E
LDA $1609,Y
SEC
SBC $1E
BEQ no_HP
BCS lost_0     ; BNE is for losers
no_HP:
TDC
INC A          ; better than LDA #$0001
lost_0:
STA $1609,Y
not_this:
not_poison:
dead:
REP #$21       ; M won't necessarily be 16 bit based on the branches taken previously
TYA
ADC #$0025
TAY
TDC
SEP #$20
INX
CPX #$0010     ; have we done all 16 characters yet?
BNE again      ; better to branch from here than one more instruction afterwards
PLX
STX $24
PLX
STX $22
PLX
STX $20
PLX
STX $1E
PLP
ultra:
RTL

org $C06CF3
STZ $11DF  ; zero party-wide effect
LDY $00
STY $1448  ; zero bitfield for tintinabar, 1 bit for each character
STZ $1B   ; zero out character number
again2:
LDA $0867,Y
ASL A
BPL loop2
LSR A
AND #$07
CMP $1A6D
BNE loop2
LDA $1B
JSL $C20E77  ; equipment check function
JSR bit_check
loop2:
REP #$21
TYA
ADC #$0029
TAY
SEP #$20
INC $1B
CPY #$0290  ; have we checked all 16 characters yet?
BNE again2  ; branch if not
TDC
RTS

org $C0DEF6
bit_check:
LDA $11D8    ; load special 3
BPL no_tin   ; branch if this character doesn't have the tintinabar
LDA $1B      ; load character number
PHY   ; save the character index for now
INC A  ; character number is 0-based, make it 1-based
TAY   ; transfer it
REP #$20
SEC   ; set carry for the first bit check
TDC   ; zero A so readings aren't tainted
again3:
ROL A  ; move the bit left
DEY
BNE again3  ; decrease and shift until we hit the character number we're on
TSB $1448  ; set the bit for this character to signify wearing the tintinabar
PLY   ; re-load our character index
no_tin:
RTS

continue_tin:
STY $4204      ; store character index
LDA #$25
STA $4206      ; divide by #$25
JSL ultra
TDC
LDA $4214      ; A = character number
PHX
INC A
TAX
REP #$20
SEC
TDC
loopy:
ROL A
DEX
BNE loopy
PLX
BIT $1448    ; is the bit set for this character?
SEP #$20
RTS

org $C31DA4
JSR $3548
LDA $08   ; load controller 1
BPL no_A  ; branch if not pressing A
JMP $2E62

no_A:
LDA $09
BIT #$02
BEQ no_left
JMP $2EC6

no_left:
BPL no_B
STZ $0205
JSR $0EA9
JSR equip_check
TDC
DEC A
STA $27
STZ $26
no_B:
RTS

equip_check:
STZ $11DF  ; zero out party-wide byte
STZ $1448  ; zero out tintinabar byte 1
STZ $1449  ; zero out tintinabar byte 2
LDX #$0003
again4:
LDA $69,X
BMI check_more
JSL $C20E77  ; equipment check function
JSR tin2
check_more:
DEX
BPL again4
RTS

org $C3F16C
tin2:
LDA $11D8   ; load special 3
BPL no_tin2
TDC    ; clean out upper A
LDA $69,X  ; load character
INC A   ; character is 0-based, make it 1-based
TAY   ; and transfer it
SEC   ; set it for the first bit
TDC   ; now clean A
REP #$20
again5:
ROL A   ; rotate!
DEY
BNE again5
TSB $1448   ; set the tintinabar bit for this character
SEP #$20
no_tin2:
RTS
